<template>
  <div class="v-container">
    <div class="v-row">
      <div class="v-col col-12">
        <v-card>
          <v-card-title>
            <span class="text-h5">{{ formTitle }}</span>
          </v-card-title>
<!--          форма данных сотрудника  -->
          <v-card-text>
            <v-container>
              <v-row>
                <v-col
                    cols="12"
                    sm="6"
                    md="4"
                >
                  <v-text-field
                      :readonly="!isEdit"
                      v-model="localEmployee.sName"
                      label="Фамилия сотрудника"

                  ></v-text-field>
                </v-col>
                <v-col
                    cols="12"
                    sm="6"
                    md="4"
                >
                  <v-text-field
                      :readonly="!isEdit"
                      v-model="localEmployee.name"
                      label="Имя сотрудника"
                  ></v-text-field>
                </v-col>
                <v-col
                    cols="12"
                    sm="6"
                    md="4"
                >
                  <v-text-field
                      :readonly="!isEdit"
                      v-model="localEmployee.mName"
                      label="Отчество сотрудника"
                  ></v-text-field>
                </v-col>
                <v-col
                    cols="12"
                    sm="6"
                    md="6"
                >
                  <v-text-field
                      :readonly="!isEdit"
                      v-model="localEmployee.eMail"
                      label="E-mail сотрудника"
                  ></v-text-field>
                </v-col>
                <v-col
                    cols="12"
                    sm="6"
                    md="6"
                >
                  <v-select
                      v-model="localEmployee.friends"
                      :items="employees.filter(el => el.id !== employee.id)"
                      :readonly="!isEdit"
                      label="Выбрать друзей"
                      chips
                      multiple
                      item-text="name"
                      item-value="id"
                  >
                  </v-select>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
<!--           выбираем кнопки на основании того, в каком статусе открыта форма   -->
          <template v-if="isEdit">
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="$router.go(-1)"
              >
                Отменить
              </v-btn>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="onSaveItem"
              >
                Сохранить
              </v-btn>
            </v-card-actions>
          </template>
          <template v-else>
            <v-card-actions>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="showFriends = !showFriends"
              >
                {{ showFriends ? "Скрыть связи работника" : "Показать связи работника" }}
              </v-btn>
              <v-spacer></v-spacer>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="$router.go(-1)"
              >
                Закрыть
              </v-btn>
            </v-card-actions>
          </template>
        </v-card>
        <v-divider class="my-3"/>
        <v-expand-transition>
<!--          по запрос открываем окошко с друзьями сотрудника    -->
          <v-card
              v-show="showFriends"
              class="mx-auto bg-secondary"
          >
            <v-card-text v-if="employee.friends.length">
              <p v-for="friend in getFriends">{{friend}}</p>
            </v-card-text>
            <v-card-text v-else>
              У сотркдника нет друзей
            </v-card-text>
          </v-card>
        </v-expand-transition>
      </div>
    </div>
  </div>
</template>

<script>
import {mapMutations, mapState} from "vuex";

export default {
  name: "Employee",
  model: {
    event: 'input'
  },
  data: () => ({
    showFriends: false,
    localEmployee: {}
  }),
  computed: {
    ...mapState(['employee', 'employees']),
    isEdit() {
      return this.$route.params.method !== "view"
    },  // узнаем можно ли править форму
    formTitle() {
      switch (this.$route.params.method) {
        case "view":
          return "Просмотр данных сотрудника"
        case "edit":
          return "Редактирование сотрудника"
        case "create":
          this.fillEmployee()
          return "Создание сотрудника"
      }
    },  // получаем заголовок формы
    getFriends() { // получаем список друзей по именам
      return this.employee.friends.map(el => {
        const empl = this.employees.find(item => item.id === el)
        return `${empl.sName} ${empl.name} ${empl.mName}`
      })
    },
  },
  mounted() {
    this.localEmployee = JSON.parse(JSON.stringify(this.employee)) // заполняемлокальное хранилище данными сотрудника
  },
  methods: {
    ...mapMutations(['fillEmployee', 'saveItem', 'fillEmployee']),
    onSaveItem() {
      this.saveItem(this.localEmployee) // вызываем метод сохранения сотрудника
      this.$router.go(-1) // возвращаемся в список сотрудников
    },
  },
}
</script>
